# coding: utf-8
"""Waylay Alarms models.

This code was generated from the OpenAPI documentation of 'Waylay Alarms'

Generated by OpenAPI Generator (https://openapi-generator.tech)

Do not edit the class manually.

"""

from __future__ import annotations

from datetime import datetime

from pydantic import (
    ConfigDict,
    Field,
    StrictStr,
)
from typing_extensions import (
    Annotated,  # >=3.11
)
from waylay.sdk.api._models import BaseModel as WaylayBaseModel

from ..models.alarm_severity import AlarmSeverity
from ..models.alarm_status import AlarmStatus
from ..models.id_object import IdObject


class AlarmEventAlarm(WaylayBaseModel):
    """Summary representation of an alarm.."""

    id: StrictStr = Field(description="Unique alarm identifier.")
    tenant_id: StrictStr = Field(alias="tenantId")
    creation_time: datetime = Field(alias="creationTime")
    type: StrictStr = Field(description="Type of the alarm.")
    text: StrictStr = Field(description="Description of the alarm.")
    timestamp: datetime
    source: IdObject
    severity: AlarmSeverity
    status: AlarmStatus
    count: Annotated[int, Field(strict=True, ge=1)]

    model_config = ConfigDict(
        populate_by_name=True, protected_namespaces=(), extra="ignore"
    )
